clear all;
close all;
% Define constants
Tf = 1;     % Final time
Tobs = 1;   % Observation time
a = 0;      % Left endpoint
b = 1;      % Right endpoint
Nt = 200;   % # of intervals in the t - direction
Nx =  10;   % # of intervals in the x - direction
%
h = (b-a) / Nx;
tau = Tf / Nt;
Ntobs = round(Tobs/tau) + 1;
% Calculate the Courant number mu;
mu = tau / (h*h)
mu2 = 1 - 2 * mu;
% Initialize 
t = linspace(0,Tf,Nt+1);
x = linspace(a,b,Nx+1);
U = zeros(Nt+1,Nx+1);
%
% Impose the initial condition
U(1,:) = u0(x);
%
for m = 2 : Nt + 1
    for i = 2 : Nx
        U(m,i) = mu * U(m-1,i-1) + mu2 * U(m-1,i) + mu * U(m-1,i+1);
    end
end
uex = exact(t(Ntobs),x);
uap = U(Ntobs,:);
plot(x,uex,'-o',x,uap,'r-*');
legend('exact','approximate');
title(['Forward f.d. for u_t = u_{xx}. Time t = ' num2str(t(Ntobs))],'FontSize',16);
xlabel('x');
grid on;
err = norm(uex-uap)/norm(uex)
% tt = [0 0.1 0.2 0.3]
% nt = round(tt/tau) + 1
% figure
% for i = 1:length(tt)
%     uappr = U(nt(i),:);
%     plot(x,uappr)
%     hold on
% end
